import * as React from 'react';
export declare const enum Status {
    AWAITING = 0,
    SUCCESS = 1,
    FAILED = 2
}
/**
 * Render components based on the state of a promise. Renders `then` prop when the promise is resolved.
 * Renders `catch` prop when the promise is rejected. Renders `placeholder` while the promise is not
 * resolved nor rejected.
 */
export declare class Await<T extends any> extends React.PureComponent<{
    promise: Promise<T> | void;
    placeholder?: any;
    then?: React.ReactElement<any> | ((value?: T) => React.ReactElement<any>);
    catch?: any;
}, {
    loading: boolean;
    value: any;
    reason: any;
}> {
    promise: Promise<any> | void;
    constructor(props: any);
    render(): any;
}
