"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.Await = void 0;
var React = require("react");
var PropsTypes = require("prop-types");
var util_1 = require("./util");
/**
 * Render components based on the state of a promise. Renders `then` prop when the promise is resolved.
 * Renders `catch` prop when the promise is rejected. Renders `placeholder` while the promise is not
 * resolved nor rejected.
 */
var Await = /** @class */ (function (_super) {
    __extends(Await, _super);
    function Await(props) {
        var _this = _super.call(this, props) || this;
        _this.promise = null;
        _this.state = {
            loading: true,
            value: void 0,
            reason: void 0
        };
        return _this;
    }
    Await.prototype.render = function () {
        var _this = this;
        var _a = this.props, promise = _a.promise, placeholder = _a.placeholder, then = _a.then, _catch = _a.catch;
        if (!this.state.loading && this.promise && this.promise !== promise) {
            Promise.resolve().then(function () { return _this.setState({
                loading: true
            }); });
        }
        this.promise = promise;
        if (promise && typeof promise.then === 'function') {
            promise.then(function (value) {
                _this.setState({
                    loading: false,
                    value: value,
                    reason: void 0
                });
            }, function (reason) {
                _this.setState({
                    loading: false,
                    value: void 0,
                    reason: reason
                });
            });
        }
        if (this.state.loading && placeholder) {
            return util_1.toElement(placeholder);
        }
        else if (this.state.value) {
            return util_1.toElement(then, this.state.value);
        }
        else if (this.state.reason) {
            return util_1.toElement(_catch, this.state.reason);
        }
        return null;
    };
    return Await;
}(React.PureComponent));
exports.Await = Await;
Await.propTypes = {
    promise: PropsTypes.any.isRequired,
    then: PropsTypes.any.isRequired,
    placeholder: PropsTypes.any,
    catch: PropsTypes.any
};
//# sourceMappingURL=await.js.map